from discord.ext import commands
import contextlib
import textwrap
import io
import subprocess
import discord
import asyncio
from discord.ext.buttons import Paginator
from traceback import format_exception
import psutil
import os
import sys

def clean_code(content):
    if content.startswith("```") and content.endswith("```"):
        return "\n".join(content.split("\n")[1:])[:-3]
    else:
        return content

class Pag(Paginator):
    async def teardown(self):
        try:
            await self.page.clear_reactions()
        except discord.HTTPException:
            pass

class discord_debug(commands.Cog):
    def __init__(self, bot):
      self.bot = bot
      
    @commands.group(aliases=["dd"])
    async def discord_debug(self,ctx):
      if ctx.invoked_subcommand is None:
        await ctx.send('A subcommand is required after the main command.')
    
    @discord_debug.command()
    @commands.is_owner()
    async def reboot(self,ctx):
      await ctx.send("restarting")
      await self.bot.change_presence(status=discord.Status.idle,activity=discord.Game(name='restarting🔄', type=1))
      python = sys.executable
      os.execl(python, python, *sys.argv)
      
    @discord_debug.command()
    @commands.is_owner()
    async def reload(self,ctx,text):
      self.bot.reload_extension(text)
      
    @discord_debug.command()
    @commands.is_owner()
    async def load(self,ctx,text):
      self.bot.load_extension(text)
      
    @discord_debug.command()
    @commands.is_owner()
    async def unload(self,ctx,text):
      self.bot.unload_extension(text)
      
    @discord_debug.command()
    async def status(self,ctx):
      embed = discord.Embed(title="status",description="Now loading...")
      m=await ctx.send(embed=embed)
      embed = discord.Embed(title="status")
      embed.add_field(name="discord.py version",value=discord.__version__,inline=False)
      embed.add_field(name="Memory",value=f"{psutil.virtual_memory().percent}%",inline=False)
      embed.add_field(name="CPU",value=f"{psutil.cpu_percent(interval=1)}%",inline=False)
      embed.add_field(name="Disk",value=f"{psutil.disk_usage('/').percent}%",inline=False)
      embed.add_field(name="ping値",value=f"{round(self.bot.latency * 1000)}ms",inline=False)
      await m.edit(embed=embed)
      
    @discord_debug.command()
    @commands.is_owner()
    async def shell(self,ctx, *, code):
      process = (subprocess.Popen(code, stdout=subprocess.PIPE,shell=True).communicate()[0]).decode('utf-8')
      await ctx.send(process)
      pager = Pag(
        timeout=100,
        entries=[process[i: i + 2000] for i in range(0, len(process), 2000)],
        length=1,
        prefix="```bash\n",
        suffix="```"
      )
      
    @discord_debug.command()
    @commands.is_owner()
    async def update(self, ctx):
      m=await ctx.send("updating...🔄")
      cmd="pip install --upgrade discord-debug"
      (subprocess.Popen(cmd, stdout=subprocess.PIPE,shell=True).communicate()[0]).decode('utf-8')
      await m.edit("update is finish.✅\nloading...🔄")
      self.bot.reload_extension("discord_debug")
      await m.edit("load and update is finish✅")
      
    @discord_debug.command()
    @commands.is_owner()
    async def eval(ctx, *, code):
      code = clean_code(code)
      local_variables = {
        "discord": discord,
        "commands": commands,
        "bot": self.bot,
        "ctx": ctx,
        "channel": ctx.channel,
        "author": ctx.author,
        "guild": ctx.guild,
        "message": ctx.message
      }
      stdout = io.StringIO()
      try:
        with contextlib.redirect_stdout(stdout):
          exec(
            f"async def func():\n{textwrap.indent(code, '    ')}", local_variables,
            )

          obj = await local_variables["func"]()
          result = f"{stdout.getvalue()}\n-- {obj}\n"
      except Exception as e:
        result = "".join(format_exception(e, e, e.__traceback__))
      pager = Pag(
        timeout=100,
        entries=[result[i: i + 2000] for i in range(0, len(result), 2000)],
        length=1,
        prefix="```py\n",
        suffix="```"
        )
      await pager.start(ctx)
    
def setup(bot):
  return bot.add_cog(discord_debug(bot))